import normalizeColor from "normalize-css-color";

var processColor = function processColor(color) {
  var opacity = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  if (color === undefined || color === null || opacity === 1 && typeof color === "string" && color.charAt(0) !== "#") {
    return color;
  }

  // convert number and hex
  var int32Color = normalizeColor(color);
  if (int32Color === null) {
    return undefined;
  }

  // convert 0xrrggbbaa into rgba
  var rgba = normalizeColor.rgba(int32Color);
  rgba.a = rgba.a.toFixed(1);
  var r = rgba.r,
      g = rgba.g,
      b = rgba.b,
      a = rgba.a;

  return "rgba(" + r + "," + g + "," + b + "," + a * opacity + ")";
};

export default processColor;