import isDisabled from "./isDisabled";

var propsToTabIndex = function propsToTabIndex(props) {
  var role = props.accessibilityRole;
  var focusable = !isDisabled(props) && props.importantForAccessibility !== "no" && props.importantForAccessibility !== "no-hide-descendants";

  // Assume that 'link' is focusable by default (uses <a>).
  // Assume that 'button' is not (uses <div role='button'>) but must be treated as such.
  if (role === "link") {
    if (props.accessible === false || !focusable) {
      return "-1";
    }
  } else if (role === "button") {
    if (props.accessible !== false && focusable) {
      return "0";
    }
  } else {
    if (props.accessible === true && focusable) {
      return "0";
    }
  }
};

export default propsToTabIndex;