"use strict";

exports.__esModule = true;
var roleComponents = {
  article: "article",
  banner: "header",
  complementary: "aside",
  contentinfo: "footer",
  form: "form",
  label: "label",
  link: "a",
  list: "ul",
  listitem: "li",
  main: "main",
  navigation: "nav",
  region: "section"
};

var emptyObject = {};

var propsToAccessibilityComponent = function propsToAccessibilityComponent() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;

  var role = props.accessibilityRole;
  if (role) {
    if (role === "heading") {
      var level = props["aria-level"] || 1;
      return "h" + level;
    }
    return roleComponents[role];
  }
};

exports.default = propsToAccessibilityComponent;
module.exports = exports["default"];