"use strict";

exports.__esModule = true;

var _isDisabled = require("./isDisabled");

var _isDisabled2 = _interopRequireDefault(_isDisabled);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propsToTabIndex = function propsToTabIndex(props) {
  var role = props.accessibilityRole;
  var focusable = !(0, _isDisabled2.default)(props) && props.importantForAccessibility !== "no" && props.importantForAccessibility !== "no-hide-descendants";

  // Assume that 'link' is focusable by default (uses <a>).
  // Assume that 'button' is not (uses <div role='button'>) but must be treated as such.
  if (role === "link") {
    if (props.accessible === false || !focusable) {
      return "-1";
    }
  } else if (role === "button") {
    if (props.accessible !== false && focusable) {
      return "0";
    }
  } else {
    if (props.accessible === true && focusable) {
      return "0";
    }
  }
};

exports.default = propsToTabIndex;
module.exports = exports["default"];